﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.3
@EndOfDesignText@
#DesignerProperty: Key: SelectionColor, DisplayName: Selection Color, FieldType: Color, DefaultValue: 0xFF0066FF
#Event: CropCompleted
Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private xui As XUI 'ignore
	Private ImageView As B4XView
	Private ColorBC, GreyBC, TargetBC As BitmapCreator
	Private OriginalBmp As B4XBitmap
	Private SelectionRect As B4XRect
	Private pnl As B4XView
	Private sx, sy, sx2, sy2 As Int   ', OldLOrR, OldTOrB As Int
	Private  MoveUpper, MoveLeft As Boolean
	Private clr As Int
	Private OffsetX, OffsetY As Int
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	SelectionRect.Initialize(0, 0, 0, 0)
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	clr = xui.PaintOrColorToColor(Props.Get("SelectionColor"))
	Dim iv As ImageView
	iv.Initialize("")
	ImageView = iv
	mBase.AddView(ImageView, 0, 0, 0, 0)
	pnl = xui.CreatePanel("pnl")
	mBase.AddView(pnl, 0, 0, 0, 0)
	Base_Resize(mBase.Width, mBase.Height)
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	pnl.SetLayoutAnimated(0, 0, 0, Width, Height)
End Sub

Private Sub pnl_Touch (Action As Int, X As Float, Y As Float)
	x = (x - OffsetX)/ xui.Scale
	y = (y - OffsetY) / xui.Scale
	x = Max(0, Min(ColorBC.mWidth - 1, X))
	y = Max(0, Min(ColorBC.mHeight - 1, Y))
	Select Action
		Case pnl.TOUCH_ACTION_DOWN
			If ((X < SelectionRect.Right) And (X > SelectionRect.Left)) And ((Y >SelectionRect.Top) And (Y < SelectionRect.Bottom)) Then
				sx2 = X
				sy2 = Y
				If (sx2 < (SelectionRect.Width / 2)) Then MoveLeft = True Else MoveLeft = False
				If (sy2 < (SelectionRect.Height / 2)) Then MoveUpper = True Else MoveUpper = False
				'If MoveLeft Then OldLOrR = SelectionRect.Right Else OldLOrR = SelectionRect.Left
				'If MoveUpper Then OldTOrB = SelectionRect.Bottom Else OldTOrB = SelectionRect.Top
			Else
				SelectionRect.Left = 0
				SelectionRect.Top = 0
				SelectionRect.Right = 0
				SelectionRect.Bottom = 0
				sx = X
				sy = Y
				sx2 = 0
				sy2 = 0
			End If
		Case pnl.TOUCH_ACTION_MOVE
			If (sx2 > 0) Or (sy2 > 0) Then
				If MoveLeft Then
					SelectionRect.Left = SelectionRect.Left + (X - sx2)
					'SelectionRect.Right = OldLOrR
				Else
					Log(SelectionRect.Right)
					SelectionRect.Right = SelectionRect.Right + (X - sx2)
					'SelectionRect.Left = OldLOrR
				End If
				sx2 = X
				If MoveUpper Then 
					SelectionRect.Top = SelectionRect.Top + (Y - sy2)
					'SelectionRect.Bottom = OldTOrB
				Else
					SelectionRect.Bottom = SelectionRect.Bottom + (Y - sy2)
					'SelectionRect.Top = OldTOrB
				End If
				sy2 = Y
			Else
				SelectionRect.Left = Min(sx, X)
				SelectionRect.Top = Min(sy, Y)
				SelectionRect.Right = Max(sx, X)
				SelectionRect.Bottom = Max(sy, Y)
			End If
		Case pnl.TOUCH_ACTION_UP
			If IsValidSelection Then
				CallSubDelayed(mCallBack, mEventName & "_CropCompleted")
			End If
	End Select
	UpdateTarget
End Sub

Public Sub SetBitmap (bmp As B4XBitmap)
	OriginalBmp = bmp
	Dim FitBitmap As B4XBitmap = bmp.Resize(pnl.Width, pnl.Height, True)
	OffsetX = (pnl.Width - FitBitmap.Width) / 2
	OffsetY = (pnl.Height - FitBitmap.Height) / 2
	ImageView.SetLayoutAnimated(0, OffsetX, OffsetY, FitBitmap.Width, FitBitmap.Height)
	ColorBC.Initialize(FitBitmap.Width / FitBitmap.Scale, FitBitmap.Height / FitBitmap.Scale)
	ColorBC.CopyPixelsFromBitmap(FitBitmap)
	GreyBC.Initialize(ColorBC.mWidth, ColorBC.mHeight)
	TargetBC.Initialize(ColorBC.mWidth, ColorBC.mHeight)
	'greyscale
	Dim argb As ARGBColor
	For x = 0 To ColorBC.mWidth - 1
		For y = 0 To ColorBC.mHeight - 1
			ColorBC.GetARGB(x, y, argb)
			Dim c As Int = argb.r * 0.21 + argb.g * 0.72 + 0.07 * argb.b
			argb.r = c
			argb.g = c
			argb.b = c
			GreyBC.SetARGB(x, y, argb)
		Next
	Next
	UpdateTarget
End Sub

Private Sub UpdateTarget
	Try
		TargetBC.DrawBitmapCreator(GreyBC, GreyBC.TargetRect, 0, 0, True)
		TargetBC.DrawBitmapCreator(ColorBC, SelectionRect, SelectionRect.Left, SelectionRect.Top, True)
		DrawRect
		ImageView.SetBitmap(TargetBC.Bitmap)
	Catch
		ToastMessageShow(LastException.Message, False)
	End Try
End Sub

Private Sub DrawRect
	'no bounds checks
	Try
	Dim a As ARGBColor
	TargetBC.ColorToARGB(clr, a)
	For y = SelectionRect.Top To SelectionRect.Bottom - 1
		TargetBC.SetARGB(SelectionRect.Left, y, a)
		TargetBC.SetARGB(SelectionRect.Right - 1, y, a)
	Next
	For x = SelectionRect.Left To SelectionRect.Right - 1
		TargetBC.SetARGB(x, SelectionRect.Top, a)
		TargetBC.SetARGB(x, SelectionRect.Bottom - 1, a)
	Next
	Catch
		ToastMessageShow(LastException.Message, False)
	End Try
End Sub

Public Sub IsValidSelection As Boolean
	Return SelectionRect.Width > 5 And SelectionRect.Height > 5
End Sub

Public Sub GetCroppedBitmap As B4XBitmap
	Try
		Dim fx As Float = OriginalBmp.Width / TargetBC.mWidth
		Dim fy As Float = OriginalBmp.Height / TargetBC.mHeight
		Return OriginalBmp.Crop(SelectionRect.Left * fx, SelectionRect.Top * fy, SelectionRect.Width * fx, SelectionRect.Height * fy)
	Catch
		 ToastMessageShow(LastException.Message, False)
	End Try
	
End Sub
